<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWebUrunResim ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfWebUrunResim
 * @subpackage Arrays
 */
class ArrayOfWebUrunResim extends AbstractStructArrayBase
{
    /**
     * The WebUrunResim
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WebUrunResim[]
     */
    public $WebUrunResim;
    /**
     * Constructor method for ArrayOfWebUrunResim
     * @uses ArrayOfWebUrunResim::setWebUrunResim()
     * @param \StructType\WebUrunResim[] $webUrunResim
     */
    public function __construct(array $webUrunResim = array())
    {
        $this
            ->setWebUrunResim($webUrunResim);
    }
    /**
     * Get WebUrunResim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WebUrunResim[]|null
     */
    public function getWebUrunResim()
    {
        return isset($this->WebUrunResim) ? $this->WebUrunResim : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWebUrunResim method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWebUrunResim method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWebUrunResimForArrayConstraintsFromSetWebUrunResim(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWebUrunResimWebUrunResimItem) {
            // validation for constraint: itemType
            if (!$arrayOfWebUrunResimWebUrunResimItem instanceof \StructType\WebUrunResim) {
                $invalidValues[] = is_object($arrayOfWebUrunResimWebUrunResimItem) ? get_class($arrayOfWebUrunResimWebUrunResimItem) : sprintf('%s(%s)', gettype($arrayOfWebUrunResimWebUrunResimItem), var_export($arrayOfWebUrunResimWebUrunResimItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WebUrunResim property can only contain items of type \StructType\WebUrunResim, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WebUrunResim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WebUrunResim[] $webUrunResim
     * @return \ArrayType\ArrayOfWebUrunResim
     */
    public function setWebUrunResim(array $webUrunResim = array())
    {
        // validation for constraint: array
        if ('' !== ($webUrunResimArrayErrorMessage = self::validateWebUrunResimForArrayConstraintsFromSetWebUrunResim($webUrunResim))) {
            throw new \InvalidArgumentException($webUrunResimArrayErrorMessage, __LINE__);
        }
        if (is_null($webUrunResim) || (is_array($webUrunResim) && empty($webUrunResim))) {
            unset($this->WebUrunResim);
        } else {
            $this->WebUrunResim = $webUrunResim;
        }
        return $this;
    }
    /**
     * Add item to WebUrunResim value
     * @throws \InvalidArgumentException
     * @param \StructType\WebUrunResim $item
     * @return \ArrayType\ArrayOfWebUrunResim
     */
    public function addToWebUrunResim(\StructType\WebUrunResim $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WebUrunResim) {
            throw new \InvalidArgumentException(sprintf('The WebUrunResim property can only contain items of type \StructType\WebUrunResim, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WebUrunResim[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WebUrunResim|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WebUrunResim|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WebUrunResim|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WebUrunResim|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WebUrunResim|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WebUrunResim
     */
    public function getAttributeName()
    {
        return 'WebUrunResim';
    }
}
