<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UrunOlusturmaGrup StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:UrunOlusturmaGrup
 * @subpackage Structs
 */
class UrunOlusturmaGrup extends AbstractStructBase
{
    /**
     * The Aktif
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Aktif;
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Id;
    /**
     * The Resim
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Resim;
    /**
     * The Tanim
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Tanim;
    /**
     * The UrunOlusturmaUrunListe
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfUrunOlusturmaUrun
     */
    public $UrunOlusturmaUrunListe;
    /**
     * Constructor method for UrunOlusturmaGrup
     * @uses UrunOlusturmaGrup::setAktif()
     * @uses UrunOlusturmaGrup::setId()
     * @uses UrunOlusturmaGrup::setResim()
     * @uses UrunOlusturmaGrup::setTanim()
     * @uses UrunOlusturmaGrup::setUrunOlusturmaUrunListe()
     * @param bool $aktif
     * @param int $id
     * @param string $resim
     * @param string $tanim
     * @param \ArrayType\ArrayOfUrunOlusturmaUrun $urunOlusturmaUrunListe
     */
    public function __construct($aktif = null, $id = null, $resim = null, $tanim = null, \ArrayType\ArrayOfUrunOlusturmaUrun $urunOlusturmaUrunListe = null)
    {
        $this
            ->setAktif($aktif)
            ->setId($id)
            ->setResim($resim)
            ->setTanim($tanim)
            ->setUrunOlusturmaUrunListe($urunOlusturmaUrunListe);
    }
    /**
     * Get Aktif value
     * @return bool|null
     */
    public function getAktif()
    {
        return $this->Aktif;
    }
    /**
     * Set Aktif value
     * @param bool $aktif
     * @return \StructType\UrunOlusturmaGrup
     */
    public function setAktif($aktif = null)
    {
        // validation for constraint: boolean
        if (!is_null($aktif) && !is_bool($aktif)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($aktif, true), gettype($aktif)), __LINE__);
        }
        $this->Aktif = $aktif;
        return $this;
    }
    /**
     * Get Id value
     * @return int|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \StructType\UrunOlusturmaGrup
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get Resim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getResim()
    {
        return isset($this->Resim) ? $this->Resim : null;
    }
    /**
     * Set Resim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $resim
     * @return \StructType\UrunOlusturmaGrup
     */
    public function setResim($resim = null)
    {
        // validation for constraint: string
        if (!is_null($resim) && !is_string($resim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($resim, true), gettype($resim)), __LINE__);
        }
        if (is_null($resim) || (is_array($resim) && empty($resim))) {
            unset($this->Resim);
        } else {
            $this->Resim = $resim;
        }
        return $this;
    }
    /**
     * Get Tanim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTanim()
    {
        return isset($this->Tanim) ? $this->Tanim : null;
    }
    /**
     * Set Tanim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tanim
     * @return \StructType\UrunOlusturmaGrup
     */
    public function setTanim($tanim = null)
    {
        // validation for constraint: string
        if (!is_null($tanim) && !is_string($tanim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tanim, true), gettype($tanim)), __LINE__);
        }
        if (is_null($tanim) || (is_array($tanim) && empty($tanim))) {
            unset($this->Tanim);
        } else {
            $this->Tanim = $tanim;
        }
        return $this;
    }
    /**
     * Get UrunOlusturmaUrunListe value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfUrunOlusturmaUrun|null
     */
    public function getUrunOlusturmaUrunListe()
    {
        return isset($this->UrunOlusturmaUrunListe) ? $this->UrunOlusturmaUrunListe : null;
    }
    /**
     * Set UrunOlusturmaUrunListe value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfUrunOlusturmaUrun $urunOlusturmaUrunListe
     * @return \StructType\UrunOlusturmaGrup
     */
    public function setUrunOlusturmaUrunListe(\ArrayType\ArrayOfUrunOlusturmaUrun $urunOlusturmaUrunListe = null)
    {
        if (is_null($urunOlusturmaUrunListe) || (is_array($urunOlusturmaUrunListe) && empty($urunOlusturmaUrunListe))) {
            unset($this->UrunOlusturmaUrunListe);
        } else {
            $this->UrunOlusturmaUrunListe = $urunOlusturmaUrunListe;
        }
        return $this;
    }
}
